;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime/Ieee/fixnum.scm              */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Fri Jan 20 10:06:37 1995                          */
;*    Last change :  Tue Aug 21 13:37:50 2007 (serrano)                */
;*    -------------------------------------------------------------    */
;*    6.5. Numbers (page 18, r4) The `fixnum' functions                */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __r4_numbers_6_5_fixnum
   
   (import  __error)
   
   (use     __type
	    __bigloo
	    __tvector
	    __r4_numbers_6_5
	    __r4_numbers_6_5_flonum
	    __r4_booleans_6_1
	    __r4_vectors_6_8
	    __r4_strings_6_7
	    __r4_characters_6_6
	    __r4_symbols_6_4
	    __r4_pairs_and_lists_6_3
	    
	    __evenv)

   (extern  (macro c-fixnum?::bool (::obj) "INTEGERP")
	    (macro c-elong?::bool (::obj) "ELONGP")
	    (macro c-llong?::bool (::obj) "LLONGP")
	    (macro $minvalfx::long "(LONG_MIN >> TAG_SHIFT)")
	    (macro $maxvalfx::long "(LONG_MAX >> TAG_SHIFT)")
	    (macro $minvalelong::elong "LONG_MIN")
	    (macro $maxvalelong::elong "LONG_MAX")
	    (macro $minvalllong::llong "BGL_LONGLONG_MIN")
	    (macro $maxvalllong::llong "BGL_LONGLONG_MAX")
	    (macro $elong->llong::llong (::elong) "(BGL_LONGLONG_T)")
	    (infix macro c-=fx::bool (::long ::long) "==")
	    (infix macro c-=elong::bool (::elong ::elong) "==")
	    (infix macro c-=llong::bool (::llong ::llong) "==")
	    (infix macro c-<fx::bool (::long ::long) "<")
	    (infix macro c-<elong::bool (::elong ::elong) "<")
	    (infix macro c-<llong::bool (::llong ::llong) "<")
	    (infix macro c-<=fx::bool (::long ::long) "<=")
	    (infix macro c-<=elong::bool (::elong ::elong) "<=")
	    (infix macro c-<=llong::bool (::llong ::llong) "<=")
	    (infix macro c->fx::bool (::long ::long) ">")
	    (infix macro c->elong::bool (::elong ::elong) ">")
	    (infix macro c->llong::bool (::llong ::llong) ">")
	    (infix macro c->=fx::bool (::long ::long) ">=")
	    (infix macro c->=elong::bool (::elong ::elong) ">=")
	    (infix macro c->=llong::bool (::llong ::llong) ">=")
	    (macro c-evenfx?::bool (::long) "EVENP_FX")
	    (macro c-oddfx?::bool (::long) "ODDP_FX")
	    (infix macro c-+fx::long (::long ::long) "+")
	    (infix macro c-+elong::elong (::elong ::elong) "+")
	    (infix macro c-+llong::llong (::llong ::llong) "+")
	    (infix macro c--fx::long (::long ::long) "-")
	    (infix macro c--elong::long (::elong ::elong) "-")
	    (infix macro c--llong::llong (::llong ::llong) "-")
	    (infix macro c-*fx::long (::long ::long) "*")
	    (infix macro c-*elong::elong (::elong ::elong) "*")
	    (infix macro c-*llong::llong (::llong ::llong) "*")
	    (infix macro c-/fx::long (::long ::long) "/")
	    (infix macro c-/elong::elong (::elong ::elong) "/")
	    (infix macro c-/llong::llong (::llong ::llong) "/")
	    (macro c-negfx::long (::long) "NEG")
	    (macro c-negelong::elong (::elong) "NEG")
	    (macro c-negllong::llong (::llong) "NEG")
	    (infix macro c-quotientfx::long (::long ::long) "/")
	    (infix macro c-quotientelong::elong (::elong ::elong) "/")
	    (infix macro c-quotientllong::llong (::llong ::llong) "/")
	    (infix macro c-remainderfx::long (::long ::long) "%")
	    (infix macro c-remainderelong::elong (::elong ::elong) "%")
	    (infix macro c-remainderllong::llong (::llong ::llong) "%")
	    (macro strtol::long (::string ::long ::long) "strtol")
	    (macro $strtoul::long (::string ::long ::long) "strtoul")
	    (macro strtoel::elong (::string ::long ::long) "strtol")
	    (macro $strtoeul::elong (::string ::long ::long) "strtoul")
	    (macro strtoll::llong (::string ::long ::long) "BGL_STRTOLL")
	    (macro $strtoull::llong (::string ::long ::long) "BGL_STRTOULL")
	    (c-int->string::bstring  (::long ::long) "integer_to_string")
	    
	    ($integer->string/padding::bstring  (::long ::long ::long) "integer_to_string_padding")
	    (c-elong->string::bstring  (::elong ::long) "integer_to_string")
	    (c-llong->string::bstring  (::llong ::long) "llong_to_string")
	    ($unsigned->string::bstring  (::long ::long) "unsigned_to_string")
	    ($uelong->string::bstring  (::elong ::long) "unsigned_to_string")
	    ($ullong->string::bstring  (::llong ::long) "ullong_to_string")
	    (macro $rand::int () "rand")
	    (macro $seed-rand::void (::int) "srand"))
   
   (java    (class foreign
	       (field static $minvalfx::long "MIN_VALUE_FX")
	       (field static $maxvalfx::long "MAX_VALUE_FX")
	       (field static $minvalelong::elong "MIN_VALUE_ELONG")
	       (field static $maxvalelong::elong "MAX_VALUE_ELONG")
	       (field static $minvalllong::llong "MIN_VALUE_ELONG")
	       (field static $maxvalllong::llong "MAX_VALUE_ELONG")
	       (method static c-fixnum?::bool (::obj)
		       "INTEGERP")
	       (method static c-elong?::bool (::obj)
		       "ELONGP")
	       (method static c-llong?::bool (::obj)
		       "LLONGP")
	       (method static $elong->llong::llong (::elong)
		       "ELONG_TO_LLONG")
	       (method static c-=fx::bool (::long ::long)
		       "EQ_FX")
	       (method static c-=elong::bool (::elong ::elong)
		       "EQ_ELONG")
	       (method static c-=llong::bool (::llong ::llong)
		       "EQ_LLONG")
	       (method static c-=fx::bool (::long ::long)
		       "EQ_FX")
	       (method static c-=elong::bool (::elong ::elong)
		       "EQ_ELONG")
	       (method static c-=llong::bool (::llong ::llong)
		       "EQ_LLONG")	       
	       (method static c-<fx::bool (::long ::long)
		       "LT_FX")
	       (method static c-<elong::bool (::elong ::elong)
		       "LT_ELONG")
	       (method static c-<llong::bool (::llong ::llong)
		       "LT_LLONG")
	       (method static c-<=fx::bool (::long ::long)
		       "LE_FX")
	       (method static c-<=elong::bool (::elong ::elong)
		       "LE_ELONG")
	       (method static c-<=llong::bool (::llong ::llong)
		       "LE_LLONG")
	       (method static c->fx::bool (::long ::long)
		       "GT_FX")
	       (method static c->elong::bool (::elong ::elong)
		       "GT_ELONG")
	       (method static c->llong::bool (::llong ::llong)
		       "GT_LLONG")
	       (method static c->=fx::bool (::long ::long)
		       "GE_FX")
	       (method static c->=elong::bool (::elong ::elong)
		       "GE_ELONG")
	       (method static c->=llong::bool (::llong ::llong)
		       "GE_LLONG")
	       (method static c-evenfx?::bool (::long)
		       "EVENP_FX")
	       (method static c-oddfx?::bool (::long)
		       "ODDP_FX")
	       (method static c-+fx::long (::long ::long)
		       "PLUS_FX")
	       (method static c-+elong::elong (::elong ::elong)
		       "PLUS_ELONG")
	       (method static c-+llong::llong (::llong ::llong)
		       "PLUS_LLONG")
	       (method static c--fx::long (::long ::long)
		       "MINUS_FX")
	       (method static c--elong::elong (::elong ::elong)
		       "MINUS_ELONG")
	       (method static c--llong::llong (::llong ::llong)
		       "MINUS_LLONG")
	       (method static c-*fx::long (::long ::long)
		       "MUL_FX")
	       (method static c-*elong::elong (::elong ::elong)
		       "MUL_ELONG")
	       (method static c-*llong::llong (::llong ::llong)
		       "MUL_LLONG")
	       (method static c-/fx::long (::long ::long)
		       "DIV_FX")
	       (method static c-/elong::elong (::elong ::elong)
		       "DIV_ELONG")
	       (method static c-/llong::llong (::llong ::llong)
		       "DIV_LLONG")
	       (method static c-negfx::long (::long)
		       "NEG_FX")
	       (method static c-negelong::elong (::elong)
		       "NEG_ELONG")
	       (method static c-negllong::llong (::llong)
		       "NEG_LLONG")
	       (method static c-quotientfx::long (::long ::long)
		       "QUOTIENT_FX")
	       (method static c-quotientelong::elong (::elong ::elong)
		       "QUOTIENT_ELONG")
	       (method static c-quotientllong::llong (::llong ::llong)
		       "QUOTIENT_LLONG")
	       (method static c-remainderfx::long (::long ::long)
		       "REMAINDER_FX")
	       (method static c-remainderelong::elong (::elong ::elong)
		       "REMAINDER_ELONG")
	       (method static c-remainderllong::llong (::llong ::llong)
		       "REMAINDER_LLONG")
	       (method static strtol::long (::string ::long ::long)
		       "strtol")
	       (method static $strtoul::long (::string ::long ::long)
		       "strtoul")
	       (method static strtoel::elong (::string ::long ::long)
		       "strtoll")
	       (method static $strtoeul::elong (::string ::long ::long)
		       "strtoll")
	       (method static strtouel::elong (::string ::long ::long)
		       "strtoull")
	       (method static strtoll::llong (::string ::long ::long)
		       "strtoll")
	       (method static $strtoull::llong (::string ::long ::long)
		       "strtoull")
	       (method static c-int->string::bstring (::long ::long)
		       "integer_to_string")
	       (method static $integer->string/padding::bstring  (::long ::long ::long)
		       "integer_to_string_padding")
	       
	       (method static c-elong->string::bstring (::elong ::long)
		       "elong_to_string")
	       (method static c-llong->string::bstring (::llong ::long)
		       "llong_to_string")
	       (method static $unsigned->string::bstring  (::long ::long)
		       "unsigned_to_string")
	       (method static $uelong->string::bstring (::elong ::long)
		       "uelong_to_string")
	       (method static $ullong->string::bstring (::llong ::long)
		       "ullong_to_string")
	       (method static $rand::int ()
		       "rand")
	       (method static $seed-rand::void (::int)
		       "srand")))
   
   (export  (integer?::bool ::obj)
	    (inline fixnum?::bool ::obj)
	    (inline elong?::bool ::obj)
	    (inline llong?::bool ::obj)
	    (inline make-elong::belong ::long)
	    (inline make-llong::bllong ::long)
	    (inline elong->llong::llong ::elong)
	    (inline minvalfx::long)
	    (inline maxvalfx::long)
	    (inline minvalelong::elong)
	    (inline maxvalelong::elong)
	    (inline minvalllong::llong)
	    (inline maxvalllong::llong)
	    (inline =fx::bool ::long ::long)
	    (inline =elong::bool ::elong ::elong)
	    (inline =llong::bool ::llong ::llong)
	    (inline >fx::bool ::long ::long)
	    (inline >elong::bool ::elong ::elong)
	    (inline >llong::bool ::llong ::llong)
	    (inline >=fx::bool ::long ::long)
	    (inline >=elong::bool ::elong ::elong)
	    (inline >=llong::bool ::llong ::llong)
	    (inline <fx::bool ::long ::long)
	    (inline <elong::bool ::elong ::elong)
	    (inline <llong::bool ::llong ::llong)
	    (inline <=fx::bool ::long ::long)
	    (inline <=elong::bool ::elong ::elong)
	    (inline <=llong::bool ::llong ::llong)
	    (inline zerofx?::bool ::long)
	    (inline zeroelong?::bool ::elong)
	    (inline zerollong?::bool ::llong)
	    (inline positivefx?::bool ::long)
	    (inline positiveelong?::bool ::elong)
	    (inline positivellong?::bool ::llong)
	    (inline negativefx?::bool ::long)
	    (inline negativeelong?::bool ::elong)
	    (inline negativellong?::bool ::llong)
	    (inline odd?::bool ::obj)
	    (inline oddfx?::bool ::long)
	    (inline oddelong?::bool ::elong)
	    (inline oddllong?::bool ::llong)
	    (inline even?::bool ::obj)
	    (inline evenfx?::bool ::long)
	    (inline evenelong?::bool ::elong)
	    (inline evenllong?::bool ::llong)
	    (minfx::long ::long . pair)
	    (minelong::elong ::elong . pair)
	    (minllong::llong ::llong . pair)
	    (maxfx::long ::long . pair)
	    (maxelong::elong ::elong . pair)
	    (maxllong::llong ::llong . pair)
	    (inline +fx::long ::long ::long)
	    (inline +elong::elong ::elong ::elong)
	    (inline +llong::llong ::llong ::llong)
	    (inline -fx::long ::long ::long)
	    (inline -elong::elong ::elong ::elong)
	    (inline -llong::llong ::llong ::llong)
	    (inline *fx::long ::long ::long)
	    (inline *elong::elong ::elong ::elong)
	    (inline *llong::llong ::llong ::llong)
	    (inline /fx::long ::long ::long)
	    (inline /elong::elong ::elong ::elong)
	    (inline /llong::llong ::llong ::llong)
	    (inline negfx::long ::long)
	    (inline negelong::elong ::elong)
	    (inline negllong::llong ::llong)
	    (inline absfx::long ::long)
	    (inline abselong::elong ::elong)
	    (inline absllong::llong ::llong)
	    (remainder::obj ::obj ::obj)
	    (inline remainderfx::long ::long ::long)
	    (inline remainderelong::elong ::elong ::elong)
	    (inline remainderllong::llong ::llong ::llong)
	    (quotient::obj ::obj ::obj)
	    (inline quotientfx::long ::long ::long)
	    (inline quotientelong::elong ::elong ::elong)
	    (inline quotientllong::llong ::llong ::llong)
	    (modulo::obj ::obj ::obj)
	    (modulofx::long ::long ::long)
	    (moduloelong::elong ::elong ::elong)
	    (modulollong::llong ::llong ::llong)
	    (gcd::obj . pair)
	    (gcdfx::long . pair)
	    (gcdelong::elong . pair)
	    (gcdllong::llong . pair)
	    (lcm::obj . pair)
	    (lcmfx::long . pair)
	    (lcmelong::elong . pair)
	    (lcmllong::llong . pair)
	    (integer->string::bstring ::long #!optional (radix::long 10))
	    (integer->string/padding::bstring ::long ::long #!optional (radix::long 10))
	    (unsigned->string::bstring ::obj #!optional (radix::long 16))
	    (string->integer::long ::bstring . pair)
	    (elong->string::bstring ::elong . pair)
	    (string->elong::elong ::bstring . pair)
	    (llong->string::bstring ::llong . pair)
	    (string->llong::llong ::bstring . pair)
	    (inline random::int ::int)
	    (seed-random! ::int))
   
   (pragma  (fixnum? (predicate-of bint) no-cfa-top nesting)
	    (c-fixnum? side-effect-free (predicate-of bint) no-cfa-top nesting args-safe (effect))
	    (c-elong? side-effect-free (predicate-of belong) no-cfa-top nesting (effect))
	    (c-llong? side-effect-free (predicate-of bllong) no-cfa-top nesting (effect))
	    (integer? side-effect-free no-cfa-top nesting (effect))
	    (=fx side-effect-free no-cfa-top nesting (effect))
	    (=elong side-effect-free no-cfa-top nesting (effect))
	    (=llong side-effect-free no-cfa-top nesting (effect))
	    (=fx side-effect-free no-cfa-top nesting (effect))
	    (=elong side-effect-free no-cfa-top nesting (effect))
	    (=llong side-effect-free no-cfa-top nesting (effect))
	    (>fx side-effect-free no-cfa-top nesting (effect))
	    (>elong side-effect-free no-cfa-top nesting (effect))
	    (>llong side-effect-free no-cfa-top nesting (effect))
	    (>=fx side-effect-free no-cfa-top nesting (effect))
	    (>=elong side-effect-free no-cfa-top nesting (effect))
	    (>=llong side-effect-free no-cfa-top nesting (effect))
	    (<fx side-effect-free no-cfa-top nesting (effect))
	    (<elong side-effect-free no-cfa-top nesting (effect))
	    (<llong side-effect-free no-cfa-top nesting (effect))
	    (<=fx side-effect-free no-cfa-top nesting (effect))
	    (<=elong side-effect-free no-cfa-top nesting (effect))
	    (<=llong side-effect-free no-cfa-top nesting (effect))
	    (odd? side-effect-free no-cfa-top nesting (effect))
	    (c-oddfx? side-effect-free no-cfa-top nesting args-safe (effect))
	    (even? side-effect-free no-cfa-top nesting (effect))
	    (+fx side-effect-free no-cfa-top nesting (effect))
	    (+elong side-effect-free no-cfa-top nesting (effect))
	    (+llong side-effect-free no-cfa-top nesting (effect))
	    (-fx side-effect-free no-cfa-top nesting (effect))
	    (-elong side-effect-free no-cfa-top nesting (effect))
	    (-llong side-effect-free no-cfa-top nesting (effect))
	    (*fx side-effect-free no-cfa-top nesting (effect))
	    (*elong side-effect-free no-cfa-top nesting (effect))
	    (*llong side-effect-free no-cfa-top nesting (effect))
	    (/fx side-effect-free no-cfa-top nesting (effect))
	    (/elong side-effect-free no-cfa-top nesting (effect))
	    (/llong side-effect-free no-cfa-top nesting (effect))
	    (remainderfx side-effect-free no-cfa-top nesting (effect))
	    (remainderelong side-effect-free no-cfa-top nesting (effect))
	    (remainderllong side-effect-free no-cfa-top nesting (effect))
	    (integer->string side-effect-free no-cfa-top nesting (effect))
	    (string->integer side-effect-free no-cfa-top nesting (effect))
	    (modulo side-effect-free no-cfa-top nesting (effect))
	    (quotientfx side-effect-free no-cfa-top nesting (effect))
	    (gcdfx side-effect-free no-cfa-top nesting (effect))
	    (gcdelong side-effect-free no-cfa-top nesting (effect))
	    (gcdllong side-effect-free no-cfa-top nesting (effect))
	    (lcmfx side-effect-free no-cfa-top nesting (effect))
	    (lcmelong side-effect-free no-cfa-top nesting (effect))
	    (lcmllong side-effect-free no-cfa-top nesting (effect))
	    (positivefx? side-effect-free no-cfa-top nesting (effect))
	    (positiveelong? side-effect-free no-cfa-top nesting (effect))
	    (positivellong? side-effect-free no-cfa-top nesting (effect))
	    (negativefx? side-effect-free no-cfa-top nesting (effect))
	    (negativeelong? side-effect-free no-cfa-top nesting (effect))
	    (negativellong? side-effect-free no-cfa-top nesting (effect))
	    (zerofx? side-effect-free no-cfa-top nesting (effect))
	    (zeroelong? side-effect-free no-cfa-top nesting (effect))
	    (zerollong? side-effect-free no-cfa-top nesting (effect))
	    (negfx side-effect-free no-cfa-top nesting (effect))
	    (negelong side-effect-free no-cfa-top nesting (effect))
	    (negllong side-effect-free no-cfa-top nesting (effect))
	    (c-=fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-=elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-=llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->=fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->=elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c->=llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<=fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<=elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-<=llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-oddfx? side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-evenfx? side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-+fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-+elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-+llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c--fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c--elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c--llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-*fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-*elong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-*llong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-/fx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-negfx side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-negelong side-effect-free no-cfa-top nesting args-safe (effect))
	    (c-negllong side-effect-free no-cfa-top nesting args-safe (effect))
	    (random side-effect-free no-cfa-top nesting (effect))))

;*---------------------------------------------------------------------*/
;*    integer? ...                                                     */
;*---------------------------------------------------------------------*/
(define (integer? obj)
   (or (c-fixnum? obj)
       (c-elong? obj)
       (c-llong? obj)
       (and (c-flonum? obj) (=fl obj (roundfl obj)))))

;*---------------------------------------------------------------------*/
;*    fixnum? ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (fixnum? obj)
   (c-fixnum? obj))

;*---------------------------------------------------------------------*/
;*    elong? ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (elong? obj)
   (c-elong? obj))

;*---------------------------------------------------------------------*/
;*    llong? ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (llong? obj)
   (c-llong? obj))

;*---------------------------------------------------------------------*/
;*    make-elong ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (make-elong long)
   ($long->belong long))

;*---------------------------------------------------------------------*/
;*    make-llong ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (make-llong long)
   ($long->bllong long))

;*---------------------------------------------------------------------*/
;*    elong->llong ...                                                 */
;*---------------------------------------------------------------------*/
(define-inline (elong->llong x)
   ($elong->llong x))

;*---------------------------------------------------------------------*/
;*    {min,max}val{fx,elong,llong} ...                                 */
;*---------------------------------------------------------------------*/
(define-inline (minvalfx) $minvalfx)
(define-inline (maxvalfx) $maxvalfx)
(define-inline (minvalelong) $minvalelong)
(define-inline (maxvalelong) $maxvalelong)
(define-inline (minvalllong) $minvalllong)
(define-inline (maxvalllong) $maxvalllong)

;*---------------------------------------------------------------------*/
;*    =fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (=fx n1 n2)
   (c-=fx n1 n2))

;*---------------------------------------------------------------------*/
;*    =elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (=elong n1 n2)
   (c-=elong n1 n2))

;*---------------------------------------------------------------------*/
;*    =llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (=llong n1 n2)
   (c-=llong n1 n2))

;*---------------------------------------------------------------------*/
;*    <fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (<fx n1 n2)
   (c-<fx n1 n2))

;*---------------------------------------------------------------------*/
;*    <elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (<elong n1 n2)
   (c-<elong n1 n2))

;*---------------------------------------------------------------------*/
;*    <llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (<llong n1 n2)
   (c-<llong n1 n2))

;*---------------------------------------------------------------------*/
;*    >fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (>fx n1 n2)
   (c->fx n1 n2))

;*---------------------------------------------------------------------*/
;*    >elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (>elong n1 n2)
   (c->elong n1 n2))

;*---------------------------------------------------------------------*/
;*    >llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (>llong n1 n2)
   (c->llong n1 n2))

;*---------------------------------------------------------------------*/
;*    <=fx ...                                                         */
;*---------------------------------------------------------------------*/
(define-inline (<=fx n1 n2)
   (c-<=fx n1 n2))

;*---------------------------------------------------------------------*/
;*    <=elong ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (<=elong n1 n2)
   (c-<=elong n1 n2))

;*---------------------------------------------------------------------*/
;*    <=llong ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (<=llong n1 n2)
   (c-<=llong n1 n2))

;*---------------------------------------------------------------------*/
;*    >=fx ...                                                         */
;*---------------------------------------------------------------------*/
(define-inline (>=fx n1 n2)
   (c->=fx n1 n2))

;*---------------------------------------------------------------------*/
;*    >=elong ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (>=elong n1 n2)
   (c->=elong n1 n2))

;*---------------------------------------------------------------------*/
;*    >=llong ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (>=llong n1 n2)
   (c->=llong n1 n2))

;*---------------------------------------------------------------------*/
;*    zerofx? ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (zerofx? n)
   (=fx n 0))

;*---------------------------------------------------------------------*/
;*    zeroelong? ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (zeroelong? n)
   (=elong n #e0))

;*---------------------------------------------------------------------*/
;*    zerollong? ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (zerollong? n)
   (=llong n #l0))

;*---------------------------------------------------------------------*/
;*    positivefx?  ...                                                 */
;*---------------------------------------------------------------------*/
(define-inline (positivefx? n)
   (>fx n 0))

;*---------------------------------------------------------------------*/
;*    positiveelong?  ...                                              */
;*---------------------------------------------------------------------*/
(define-inline (positiveelong? n)
   (>elong n #e0))

;*---------------------------------------------------------------------*/
;*    positivellong?  ...                                              */
;*---------------------------------------------------------------------*/
(define-inline (positivellong? n)
   (>llong n #l0))

;*---------------------------------------------------------------------*/
;*    negativefx? ...                                                  */
;*---------------------------------------------------------------------*/
(define-inline (negativefx? n)
   (<fx n 0))

;*---------------------------------------------------------------------*/
;*    negativeelong? ...                                               */
;*---------------------------------------------------------------------*/
(define-inline (negativeelong? n)
   (<elong n #e0))

;*---------------------------------------------------------------------*/
;*    negativellong? ...                                               */
;*---------------------------------------------------------------------*/
(define-inline (negativellong? n)
   (<llong n #l0))

;*---------------------------------------------------------------------*/
;*    odd? ...                                                         */
;*---------------------------------------------------------------------*/
(define-inline (odd? x)
  (cond ((fixnum? x)
	 (oddfx? x))
	((elong? x)
	 (oddelong? x))
	((llong? x)
	 (oddllong? x))
	(else
	 (error "odd?" "Illegal integer" x))))

;*---------------------------------------------------------------------*/
;*    oddfx? ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (oddfx? x)
   (c-oddfx? x))

;*---------------------------------------------------------------------*/
;*    oddelong? ...                                                    */
;*---------------------------------------------------------------------*/
(define-inline (oddelong? x)
   (if (evenelong? x) #f #t))

;*---------------------------------------------------------------------*/
;*    oddllong? ...                                                    */
;*---------------------------------------------------------------------*/
(define-inline (oddllong? x)
   (if (evenllong? x) #f #t))

;*---------------------------------------------------------------------*/
;*    even? ...                                                        */
;*---------------------------------------------------------------------*/
(define-inline (even? x)
  (cond ((fixnum? x)
	 (evenfx? x))
	((elong? x)
	 (evenelong? x))
	((llong? x)
	 (evenllong? x))
	(else
	 (error "even?" "Illegal integer" x))))

;*---------------------------------------------------------------------*/
;*    evenfx? ...                                                      */
;*---------------------------------------------------------------------*/
(define-inline (evenfx? x)
   (c-evenfx? x))

;*---------------------------------------------------------------------*/
;*    evenelong? ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (evenelong? x)
   (zeroelong? (remainderelong x #e2)))

;*---------------------------------------------------------------------*/
;*    evenllong? ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (evenllong? x)
   (zerollong? (remainderllong x #l2)))

;*---------------------------------------------------------------------*/
;*    min/max ...                                                      */
;*---------------------------------------------------------------------*/
(define-macro (min/max test-proc x . xs)
  `(let loop ((y ,x)
	      (xs ,xs))
     (if (null? xs)
	 y
	 (if (,test-proc (car xs) y)
	     (loop (car xs) (cdr xs))
	     (loop y (cdr xs))))))

;*---------------------------------------------------------------------*/
;*    minfx ...                                                        */
;*---------------------------------------------------------------------*/
(define (minfx n1 . nn)
   (min/max <fx n1 . nn))

;*---------------------------------------------------------------------*/
;*    minelong ...                                                     */
;*---------------------------------------------------------------------*/
(define (minelong n1 . nn)
   (min/max <elong n1 . nn))

;*---------------------------------------------------------------------*/
;*    minllong ...                                                     */
;*---------------------------------------------------------------------*/
(define (minllong n1 . nn)
   (min/max <llong n1 . nn))

;*---------------------------------------------------------------------*/
;*    maxfx ...                                                        */
;*---------------------------------------------------------------------*/
(define (maxfx n1 . nn)
   (min/max >fx n1 . nn))

;*---------------------------------------------------------------------*/
;*    maxelong ...                                                     */
;*---------------------------------------------------------------------*/
(define (maxelong n1 . nn)
   (min/max >elong n1 . nn))

;*---------------------------------------------------------------------*/
;*    maxllong ...                                                     */
;*---------------------------------------------------------------------*/
(define (maxllong n1 . nn)
   (min/max >llong n1 . nn))

;*---------------------------------------------------------------------*/
;*    +fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (+fx z1 z2)
   (c-+fx z1 z2))

;*---------------------------------------------------------------------*/
;*    +elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (+elong z1 z2)
   (c-+elong z1 z2))

;*---------------------------------------------------------------------*/
;*    +llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (+llong z1 z2)
   (c-+llong z1 z2))

;*---------------------------------------------------------------------*/
;*    -fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (-fx z1 z2)
   (c--fx z1 z2))

;*---------------------------------------------------------------------*/
;*    -elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (-elong z1 z2)
   (c--elong z1 z2))

;*---------------------------------------------------------------------*/
;*    -llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (-llong z1 z2)
   (c--llong z1 z2))

;*---------------------------------------------------------------------*/
;*    *fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (*fx z1 z2)
   (c-*fx z1 z2))

;*---------------------------------------------------------------------*/
;*    *elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (*elong z1 z2)
   (c-*elong z1 z2))

;*---------------------------------------------------------------------*/
;*    *llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (*llong z1 z2)
   (c-*llong z1 z2))

;*---------------------------------------------------------------------*/
;*    /fx ...                                                          */
;*---------------------------------------------------------------------*/
(define-inline (/fx z1 z2)
   (c-/fx z1 z2))

;*---------------------------------------------------------------------*/
;*    /elong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (/elong z1 z2)
   (c-/elong z1 z2))

;*---------------------------------------------------------------------*/
;*    /llong ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (/llong z1 z2)
   (c-/llong z1 z2))

;*---------------------------------------------------------------------*/
;*    negfx ...                                                        */
;*---------------------------------------------------------------------*/
(define-inline (negfx n1)
   (c-negfx n1))

;*---------------------------------------------------------------------*/
;*    negelong ...                                                     */
;*---------------------------------------------------------------------*/
(define-inline (negelong n1)
   (c-negelong n1))

;*---------------------------------------------------------------------*/
;*    negllong ...                                                     */
;*---------------------------------------------------------------------*/
(define-inline (negllong n1)
   (c-negllong n1))

;*---------------------------------------------------------------------*/
;*    absfx ...                                                        */
;*---------------------------------------------------------------------*/
(define-inline (absfx n)
   (if (<fx n 0)
       (negfx n)
       n))

;*---------------------------------------------------------------------*/
;*    abselong ...                                                     */
;*---------------------------------------------------------------------*/
(define-inline (abselong n)
   (if (<elong n #e0)
       (negelong n)
       n))

;*---------------------------------------------------------------------*/
;*    absllong ...                                                     */
;*---------------------------------------------------------------------*/
(define-inline (absllong n)
   (if (<llong n #l0)
       (negllong n)
       n))

;*---------------------------------------------------------------------*/
;*    int2op ...                                                       */
;*---------------------------------------------------------------------*/
(define-macro (int2op op x y)
  (let ((opfx (symbol-append op 'fx))
	(opelong (symbol-append op 'elong))
	(opllong (symbol-append op 'llong)))
    `(cond ((fixnum? ,x)
	    (cond ((fixnum? ,y)
		   (,opfx ,x ,y))
		  ((elong? ,y)
		   (,opelong (fixnum->elong ,x) ,y))
		  ((llong? ,y)
		   (,opllong (fixnum->llong ,x) ,y))
		  (else
		   (error ',op "not an integer" ,y))))
	   ((elong? ,x)
	    (cond ((fixnum? ,y)
		   (,opelong ,x (fixnum->elong ,y)))
		  ((elong? ,y)
		   (,opelong ,x ,y))
		  ((llong? ,y)
		   (,opllong ($elong->llong ,x) ,y))
		  (else
		   (error ',op "not an integer" ,y))))
	   ((llong? ,x)
	    (cond ((fixnum? ,y)
		   (,opllong ,x (fixnum->llong ,y)))
		  ((elong? ,y)
		   (,opllong ,x ($elong->llong ,y)))
		  ((llong? ,y)
		   (,opllong ,x ,y))
		  (else
		   (error ',op "not an integer" ,y))))
	   (else
	    (error ',op "not an integer" ,x)))))

;*---------------------------------------------------------------------*/
;*    quotient ...                                                     */
;*---------------------------------------------------------------------*/
(define (quotient n1 n2)
  (int2op quotient n1 n2))

;*---------------------------------------------------------------------*/
;*    quotientfx ...                                                   */
;*---------------------------------------------------------------------*/
(define-inline (quotientfx n1 n2)
   (c-quotientfx n1 n2))

;*---------------------------------------------------------------------*/
;*    quotientelong ...                                                */
;*---------------------------------------------------------------------*/
(define-inline (quotientelong n1 n2)
   (c-quotientelong n1 n2))

;*---------------------------------------------------------------------*/
;*    quotientllong ...                                                */
;*---------------------------------------------------------------------*/
(define-inline (quotientllong n1 n2)
   (c-quotientllong n1 n2))

;*---------------------------------------------------------------------*/
;*    remainder ...                                                    */
;*---------------------------------------------------------------------*/
(define (remainder n1 n2)
  (int2op remainder n1 n2))

;*---------------------------------------------------------------------*/
;*    remainderfx ...                                                  */
;*---------------------------------------------------------------------*/
(define-inline (remainderfx n1 n2)
   (c-remainderfx n1 n2))

;*---------------------------------------------------------------------*/
;*    remainderelong ...                                               */
;*---------------------------------------------------------------------*/
(define-inline (remainderelong n1 n2)
   (c-remainderelong n1 n2))

;*---------------------------------------------------------------------*/
;*    remainderllong ...                                               */
;*---------------------------------------------------------------------*/
(define-inline (remainderllong n1 n2)
   (c-remainderllong n1 n2))

;*---------------------------------------------------------------------*/
;*    modulo ...                                                       */
;*---------------------------------------------------------------------*/
(define (modulo n1 n2)
  (int2op modulo n1 n2))

;*---------------------------------------------------------------------*/
;*    modulofx ...                                                     */
;*---------------------------------------------------------------------*/
(define (modulofx x y)
  (let ((r (remainderfx x y)))
    (if (zerofx? r)
	r
	(if (positivefx? y)
	    (if (positivefx? r) r (+fx y r))
	    (if (negativefx? r) r (+fx y r))))))

;*---------------------------------------------------------------------*/
;*    moduloelong ...                                                  */
;*---------------------------------------------------------------------*/
(define (moduloelong x y)
  (let ((r (remainderelong x y)))
    (if (zeroelong? r)
	r
	(if (positiveelong? y)
	    (if (positiveelong? r) r (+elong y r))
	    (if (negativeelong? r) r (+elong y r))))))

;*---------------------------------------------------------------------*/
;*    modulollong ...                                                  */
;*---------------------------------------------------------------------*/
(define (modulollong x y)
  (let ((r (remainderllong x y)))
    (if (zerollong? r)
	r
	(if (positivellong? y)
	    (if (positivellong? r) r (+llong y r))
	    (if (negativellong? r) r (+llong y r))))))

;*---------------------------------------------------------------------*/
;*    gcdop ...                                                        */
;*---------------------------------------------------------------------*/
(define-macro (gcdop op x 0op)
   (let ((=op (symbol-append '= op))
	 (zeroop? (symbol-append (symbol-append 'zero op) '?))
	 (absop (symbol-append 'abs op))
	 (remainderop (symbol-append 'remainder op)))
      `(cond ((null? ,x) ,0op)
	     ((null? (cdr ,x)) (,absop (car ,x)))
	     (else
	      (letrec ((gcd2 (lambda (m n)
				(if (,zeroop? n)
				    m
				    (let ((r (,remainderop m n)))
				       (if (,=op r ,0op)
					   n
					   (gcd2 n r)))))))
		 (let loop ((result (gcd2 (,absop (car ,x)) (,absop (cadr ,x))))
			    (left (cddr ,x)))
		    (if (pair? left)
			(loop (gcd2 result (,absop (car left))) (cdr left))
			result)))))))

;*---------------------------------------------------------------------*/
;*    gcdfx ...                                                        */
;*---------------------------------------------------------------------*/
(define (gcdfx . x)
   (gcdop fx x 0))

;*---------------------------------------------------------------------*/
;*    gcdelong ...                                                     */
;*---------------------------------------------------------------------*/
(define (gcdelong . x)
   (gcdop elong x #e0))

;*---------------------------------------------------------------------*/
;*    gcdllong ...                                                     */
;*---------------------------------------------------------------------*/
(define (gcdllong . x)
   (gcdop llong x #l0))

;*---------------------------------------------------------------------*/
;*    gcd ...                                                          */
;*---------------------------------------------------------------------*/
(define (gcd . x)
   (gcdop || x 0))

;*---------------------------------------------------------------------*/
;*    lcmop ...                                                        */
;*---------------------------------------------------------------------*/
(define-macro (lcmop op x 0op 1op)
   (let ((=op (symbol-append '= op))
	 (*op (symbol-append '* op))
	 (/op (symbol-append '/ op))
	 (absop (symbol-append 'abs op))
	 (gcdop (symbol-append 'gcd op))
	 (remainderop (symbol-append 'remainder op)))
      `(cond ((null? ,x) ,1op)
	     ((null? (cdr ,x)) (,absop (car ,x)))
	     (else
	      (letrec ((lcm2 (lambda (m n)
				(let ((m (,absop m)) (n (,absop n)))
				   (cond ((,=op m n) m)
					 ((,=op (,remainderop m n) ,0op) m)
					 ((,=op (,remainderop n m) ,0op) n)
					 (else (,*op (,/op m (,gcdop m n)) n)))))))
		 (let loop ((result (lcm2 (car ,x) (cadr ,x)))
			    (left (cddr ,x)))
		    (if (pair? left)
			(loop (lcm2 result (car left)) (cdr left))
			result)))))))

;*---------------------------------------------------------------------*/
;*    lcmfx ...                                                        */
;*---------------------------------------------------------------------*/
(define (lcmfx . x)
   (lcmop fx x 0 1))

;*---------------------------------------------------------------------*/
;*    lcmelong ...                                                     */
;*---------------------------------------------------------------------*/
(define (lcmelong . x)
   (lcmop elong x #e0 #e1))

;*---------------------------------------------------------------------*/
;*    lcmllong ...                                                     */
;*---------------------------------------------------------------------*/
(define (lcmllong . x)
   (lcmop llong x #l0 #l1))

;*---------------------------------------------------------------------*/
;*    lcm ...                                                          */
;*---------------------------------------------------------------------*/
(define (lcm . x)
   (lcmop || x 0 1))

;*---------------------------------------------------------------------*/
;*    integer->string ...                                              */
;*---------------------------------------------------------------------*/
(define (integer->string x #!optional (radix::long 10))
   (case radix
      ((2 8 10 16)
       (c-int->string x radix))
      (else
       (error "integer->string" "Illegal radix" radix))))

;*---------------------------------------------------------------------*/
;*    integer->string/padding ...                                      */
;*---------------------------------------------------------------------*/
(define (integer->string/padding x padding #!optional (radix::long 10))
   (case radix
      ((2 8 10 16)
       ($integer->string/padding x padding radix))
      (else
       (error "integer->string/padding" "Illegal radix" radix))))
   
;*---------------------------------------------------------------------*/
;*    unsigned->string ...                                             */
;*---------------------------------------------------------------------*/
(define (unsigned->string x #!optional (radix::long 16))
   (case radix
      ((2 8 16)
       (cond
	  ((fixnum? x)
	   ($unsigned->string x radix))
	  ((elong? x)
	   ($uelong->string x radix))
	  ((llong? x)
	   ($ullong->string x radix))
	  (else
	   (error "unsigned->string" "Illegal integer" x))))
      (else
       (error "unsigned->string" "Illegal radix" radix))))

;*---------------------------------------------------------------------*/
;*    elong->string ...                                                */
;*---------------------------------------------------------------------*/
(define (elong->string x . radix)
   (let ((r (if (null? radix) 10 (car radix))))
      (case r
	 ((2 8 10 16)
	  (c-elong->string x r))
	 (else
	  (error "elong->string" "Illegal radix" r)))))

;*---------------------------------------------------------------------*/
;*    llong->string ...                                                */
;*---------------------------------------------------------------------*/
(define (llong->string x . radix)
   (let ((r (if (null? radix) 10 (car radix))))
      (case r
	 ((2 8 10 16)
	  (c-llong->string x r))
	 (else
	  (error "llong->string" "Illegal radix" r)))))

;*---------------------------------------------------------------------*/
;*    string->integer ...                                              */
;*---------------------------------------------------------------------*/
(define (string->integer string . radix)
   (let ((r (if (null? radix) 10 (car radix))))
      (case r
	 ((2 8 10 16)
	  (strtol string 0 r))
	 (else
	  (error "string->integer" "Illegal radix" r)))))

;*---------------------------------------------------------------------*/
;*    string->elong ...                                                */
;*---------------------------------------------------------------------*/
(define (string->elong string . radix)
   (let ((r (if (null? radix) 10 (car radix))))
      (case r
	 ((2 8 10 16)
	  (strtoel string 0 r))
	 (else
	  (error "string->elong" "Illegal radix" r)))))

;*---------------------------------------------------------------------*/
;*    string->llong ...                                                */
;*---------------------------------------------------------------------*/
(define (string->llong string . radix)
   (let ((r (if (null? radix) 10 (car radix))))
      (case r
	 ((2 8 10 16)
	  (strtoll string 0 r))
	 (else
	  (error "string->llong" "Illegal radix" r)))))

;*---------------------------------------------------------------------*/
;*    random ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (random max::int)
   (modulofx ($rand) max))

;*---------------------------------------------------------------------*/
;*    seed-random! ...                                                 */
;*---------------------------------------------------------------------*/
(define (seed-random! seed)
   ($seed-rand seed)
   seed)
